<?php

if ( is_admin() ){

	add_action('admin_menu', 'geomap_admin_menu');

	function geomap_admin_menu() {
		add_options_page(
			'WP Geoportail ShortCode',
			'WP Geoportail ShortCode',
			'administrator',
			'WP-Geoportail-ShortCode',
			'WP_Geoportail_ShortCode_html_page'
		);
	} //function
}//if

function WP_Geoportail_ShortCode_html_page() {

// See if the user has posted us some information
// If they did, this hidden field will be set to 'Y'

if( isset($_POST['submit_hidden']) && $_POST['submit_hidden'] == 'Y' ) {
    // Read/Save Values 
    $temp = $_POST['geomap_lat'];
    update_option('geomap_lat', $temp );
    
    $temp = $_POST['geomap_lon'];
    update_option('geomap_lon', $temp );
    
    $temp = $_POST['geomap_type'];
    update_option('geomap_type', $temp );
    
    $temp = $_POST['geomap_z'];
    update_option('geomap_z', $temp );
    
    $temp = $_POST['geomap_w'];
    update_option('geomap_w', $temp );
    
    $temp = $_POST['geomap_h'];
    update_option('geomap_h', $temp );
    
    $temp = $_POST['geomap_key'];
    update_option('geomap_key', $temp );

    $temp = $_POST['geomap_layers'];
    update_option('geomap_layers', $temp);

    $temp = $_POST['geomap_apiVersion'];
    update_option('geomap_apiVersion', $temp );
    // Put an settings updated message on the screen
		?>
		<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
		<?php
}

?>
<div>
	<h2>WP Geoportail ShortCode Settings</h2>

		<form method="post" action="">
		<input type="hidden" name="submit_hidden" value="Y" />
		 <?php  //wp_nonce_field('update-options'); ?>

		<table width="100%">
			<tr valign="top">
				<th width="200" scope="row">Your API Key :</th>
				<td>
					<input name="geomap_key"
								 type="text"
								 id="geomap_key"
								 value="<?php echo get_option('geomap_key'); ?>"
								 style="width:200px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">API Version :</th>
				<td>
					<select name="geomap_apiVersion" id="geomap_apiVersion" style="width:50px;" />
						<option value="1.1" <?php echo(get_option('geomap_apiVersion')=='1.1'?'selected':'') ?> > 
                                                        1.1
                                                </option>
                                                <option value="1.2" <?php echo(get_option('geomap_apiVersion')=='1.2'?'selected':'') ?> >
                                                        1.2 (default)
                                                </option>
                                                <option value="1.3" <?php echo(get_option('geomap_apiVersion')=='1.3'?'selected':'') ?> >
                                                        1.3 (experimental)
                                                </option>

						
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">Lat:</th>
				<td>
					<input name="geomap_lat"
								 type="text"
								 id="geomap_lat"
								 value="<?php echo get_option('geomap_lat'); ?>"
								 style="width:50px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">Lon:</th>
				<td>
					<input name="geomap_lon"
								 type="text"
								 id="geomap_lon"
								 value="<?php echo get_option('geomap_lon'); ?>"
								 style="width:50px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">Zoom Level:</th>
				<td>
					<input name="geomap_z"
								 type="text"
								 id="geomap_z"
								 value="<?php echo get_option('geomap_z'); ?>"
								 style="width:50px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="50" scope="row">Map Width:</th>
				<td>
					<input name="geomap_w"
								 type="text"
								 id="geomap_w"
								 value="<?php echo get_option('geomap_w'); ?>"
								 style="width:50px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">Map Height:</th>
				<td>
					<input name="geomap_h"
								 type="text"
								 id="geomap_h"
								 value="<?php echo get_option('geomap_h'); ?>"
								 style="width:50px;" />
				</td>
			</tr>
			<tr valign="top">
				<th width="200" scope="row">Map Layers : (ortho, map)</th>
				<td>
				  <select name="geomap_layers[]"
					multiple size="3">
					<option value="map" <?php if(in_array('map',get_option('geomap_layers'))) echo "selected";?> >
						IGN Maps
					</option>
					<option value="ortho" <?php if(in_array('ortho',get_option('geomap_layers'))) echo "selected";?> >
						Ortho Images
					</option>
					<option value="">blank </option>
				  </select>
				</td>
			</tr>
			<tr>
				<th width="200" scope="row">Default Viewer Type:</th>
				<td>
					<?php 
						$t = get_option('geomap_type');
						if (!($t))
							$t = 'normal';
					?>
					<input type="radio"
						name="geomap_type"
						value="normal" <?php if ($t == 'normal') echo 'checked'; ?> >
							<b>Normal</b> : this viewer type displays a full viewer, with all the tools.
					<br />
					<input type="radio"
						name="geomap_type"
						value="mini" <?php if ($t == 'mini') echo 'checked'; ?>>
							<b>Mini</b> : this viewer type displays a min viewer, without tools.
					<br />
				</td>
			</tr>
		</table>

		<p>
			<input type="submit" value="<?php _e('Save Changes') ?>" />
		</p>

	</form>
</div>
<?php

}

?>

