<?php
/*
Plugin Name: Geoportail-Shortcode beta
Description: Use API Geoportail in Wordpress
Version: 1.7
*/

include plugin_dir_path( __FILE__ ).'/Admin.php';

include_once plugin_dir_path( __FILE__ ).'/Install.php';
register_activation_hook(__FILE__,'WP_GPX_Maps_install'); 
register_deactivation_hook( __FILE__, 'WP_GPX_Maps_remove');

/******************************************************************************/
// geoportailme
/******************************************************************************/
function geoportailme($attr) {
global $post;
/******************************************************************************/
// default atts
	$attr = shortcode_atts(
			array(	
				'lat'			=> get_option("geomap_lat"), 
				'lon'			=> get_option("geomap_lon"),
				'id'	 		=> 'geoportail',
				'type'			=> get_option("geomap_type"), // normal ou mini
				'layers' 		=> get_option("geomap_layers"),
				'mapVisibility'		=> get_option("geomap_mapVisibility"),
				'mapOpacity'		=> get_option("geomap_mapOpacity"),
				'orthoVisibility'	=> get_option("geomap_orthoVisibility"),
				'orthoOpacity'		=> get_option("geomap_orthoOpacity"),
				'territory'		=> get_option("geomap_territory"),
				'z' 			=> get_option("geomap_z"),
				'w' 			=> get_option("geomap_w"),
				'h' 			=> get_option("geomap_h"),
				'kml' 			=> '',
				'kmlTitle' 		=> 'couche_kml',
				'kmlArray'			=> '',
				'gpx' 			=> '',
				'gpxTitle' 		=> 'couche_gpx',
				'gpxArray'			=> '',
				'wms' 			=> '',
				'wmsLayer'		=> '',
				'wmsTitle' 		=> 'couche_wms',
				'key'			=> get_option('geomap_key'),
				'apiVersion'		=> get_option('geomap_apiVersion'),
				'geolocate'		=> 'false',
				'geotag'		=> 'false'
				), $attr);

	$returnme = '
		<style type="text/css">
				.entry-content img {max-width: 100000%; /* override */}

				div#'. $attr['id'] .' {
					background-color:white;
					background-image:url(http://api.ign.fr/geoportail/api/js/1.2/theme/geoportal/img/loading.gif);
					background-position:center center;
					background-repeat:no-repeat;
				}
		</style>
	';
/*************************************************************************/
// Gestion de layers :
	if (gettype($attr['layers'])!==gettype(array()))
	{
		$attr['layers'] = preg_split("/[\s,]+/",$attr['layers'],-1,PREG_SPLIT_NO_EMPTY);
	}
/******************************************************************************/
	$returnme .= '
	  	<div id="' . $attr['id'] . '" style="width:' . $attr['w'] . 'px; height:' . $attr['h'] . 'px; "> </div>
	';
/******************************************************************************/
	$returnme .= '
		<!-- get the API configuration, without the API javascript : -->
    		<script type="text/javascript" src="http://api.ign.fr/geoportail/api?key=' .$attr['key'] . '&includeEngine=false&">
			<!--//--><![CDATA[//><!-- //--><!]]>
		</script>

		<script type="text/javascript">
			window.onload= function() {
					//options for creating viewer:
					var options= OpenLayers.Util.extend(
						{
							mode:"' .$attr['type'] . '",
							territory:"' .$attr['territory'] . '"
							//projection:"IGNF:GEOPORTALFXX",
							//displayProjection:"IGNF:RGF93G"
						},
						gGEOPORTALRIGHTSMANAGEMENT
					);

					var viewer= new Geoportal.Viewer.Default(
						"' .$attr['id'] . '",
						options
					);

					if (!viewer) {
						// problem ...
						OpenLayers.Console.error("Création de la carte échouée");
						return;
					}
					var map = viewer.getMap();
		';
/******************************************************************************/
//Ortho
	if (in_array('ortho', $attr['layers']  ))
	{
		$returnme .='
					viewer.addGeoportalLayers(
						["ORTHOIMAGERY.ORTHOPHOTOS:WMSC"],
						{
							"ORTHOIMAGERY.ORTHOPHOTOS:WMSC":{
								opacity:' . $attr['orthoOpacity'] . ',
								visibility:' . $attr['orthoVisibility'] . '
							}
						}
						
					);
		';
	}
/******************************************************************************/
//Map
        if (in_array('map', $attr['layers']  ))
        {
                $returnme .='
                                        viewer.addGeoportalLayers(
						["GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC"],
						{
							"GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC":{
                                               			opacity:' . $attr['mapOpacity'] . ',
                                                		visibility:' . $attr['mapVisibility'] . '
                                            		}
                                        	}
					);
                             
                ';
        }
/******************************************************************************/
//Center Map
	$returnme .= '
					map.setCenterAtLonLat(
						' . $attr['lon'] . ',
						' . $attr['lat'] . ',
						' . $attr['z'] . '
					);
		';
/******************************************************************************/
//kml
		if($attr['kml'] != '') 
		{
			$returnme .= '
					map.addLayer(
						"KML",
						"' . $attr['kmlTitle'] . '",
						"' . $attr['kml'] . '",
						{visibility:true, minZoomLevel:3, maxZoomLevel:16}
					);
			';
		}
/******************************************************************************/
//kmlArray
		if($attr['kmlArray'] != '') 
		{
			if (gettype($attr['kmlArray'])!==gettype(array()))
			{
				$attr['kmlArray'] = preg_split("/[\s;]+/",$attr['kmlArray'],-1,PREG_SPLIT_NO_EMPTY);
			}
			foreach( $attr['kmlArray'] as $kml )
			{
				if (gettype($kml)!==gettype(array()))
				{
					$kml = preg_split("/[\s,]+/",$kml,-1,PREG_SPLIT_NO_EMPTY);
				}
				if (count($kml) == 2)
				{
					$returnme .= '
						map.addLayer(
							"KML",
							"' . $kml[1] . '",
							"' . $kml[0]. '",
							{visibility:true, minZoomLevel:3, maxZoomLevel:16}
						);
					';	
				}
			}

		}
/******************************************************************************/
//gpx
		if($attr['gpx'] != '') 
		{
			$returnme .= '
					map.addLayer(
						"GPX",
						"' . $attr['gpxTitle'] . '",
						"' . $attr['gpx'] . '",
						{visibility:true, minZoomLevel:3, maxZoomLevel:16}
					);
			';
		}
/******************************************************************************/
//gpxArray
		if($attr['gpxArray'] != '') 
		{
			if (gettype($attr['gpxArray'])!==gettype(array()))
			{
				$attr['gpxArray'] = preg_split("/[\s;]+/",$attr['gpxArray'],-1,PREG_SPLIT_NO_EMPTY);
			}
			foreach( $attr['gpxArray'] as $gpx )
			{
				if (gettype($gpx)!==gettype(array()))
				{
					$gpx = preg_split("/[\s,]+/",$gpx,-1,PREG_SPLIT_NO_EMPTY);
				}
				if (count($gpx) == 2)
				{
					$returnme .= '
						map.addLayer(
							"GPX",
							"' . $gpx[1] . '",
							"' . $gpx[0]. '",
							{visibility:true, minZoomLevel:3, maxZoomLevel:16}
						);
					';	
				}
			}

		}
/******************************************************************************/
//wms
		if($attr['wms'] != '') 
		{
			$returnme .= '
					map.addLayer(
						"WMS",
						"' . $attr['wmsTitle'] . '",
						"' . $attr['wms'] . '",
	                		   	{layers: "' . $attr['wmsLayer'] . '"},
		                   		{transitionEffect: "resize"}	
					);
			';
		}
/******************************************************************************/
//geolocate
                if($attr['geolocate'] != 'false')
                {
                        $returnme .= '
					var geolocate = new OpenLayers.Control.Geolocate({
						bind: true,
						geolocationOptions: {
							enableHighAccuracy: false,
							maximumAge: 0,
							timeout: 7000
						}
					});
					map.addControl(geolocate);

					var pulsate = function(feature) {
					var point = feature.geometry.getCentroid(),
					    bounds = feature.geometry.getBounds(),
					    radius = Math.abs((bounds.right - bounds.left)/2),
					    count = 0,
					    grow = "up";

					var resize = function(){
					        if (count>16) {
					            clearInterval(window.resizeInterval);
        					}
					        var interval = radius * 0.03;
					        var ratio = interval/radius;
					        switch(count) {
					            case 4:
					            case 12:
				        	        grow = "down"; break;
					            case 8:
					                grow = "up"; break;
					        }
					        if (grow!=="up") {
					            ratio = - Math.abs(ratio);
				        	}
					        feature.geometry.resize(1+ratio, point);
					        vector.drawFeature(feature);
					        count++;
					    };
				    	window.resizeInterval = window.setInterval(resize, 50, point, radius);
					};

					var vector = new OpenLayers.Layer.Vector("myLocation");
					map.addLayers([vector]);

					geolocate.events.register("locationupdated",geolocate,function(e) {
						map.setCenterAtLonLat(
                                                	e.point.x,
                                              		e.point.y,
                                                	' . $attr['z'] . '
                                        	);
						vector.removeAllFeatures();
						var circle = new OpenLayers.Feature.Vector(
						        OpenLayers.Geometry.Polygon.createRegularPolygon(
						            new OpenLayers.Geometry.Point(e.point.x, e.point.y),
						            e.position.coords.accuracy/2,
            							40,
            							0
        						),
        						{},
        						{
							    fillColor: "#000",
							    fillOpacity: 0.1,
							    strokeWidth: 0
							}
						   );
						vector.addFeatures([
						        new OpenLayers.Feature.Vector(
						            e.point,
							    {},
						            {
						                graphicName: "cross",
						                strokeColor: "#f00",
						                strokeWidth: 2,
						                fillOpacity: 0,
						                pointRadius: 10
						            }
						        ),
						        circle
						    ]);
						pulsate(circle);
					});
					geolocate.activate();
                        ';
                }

/******************************************************************************/
//geotags
		if($attr['geotag'] != 'false')
	{
			$post_id = $post->ID;
			$lon = get_post_meta($post_id, 'geo_longitude', true);
			$lat = get_post_meta($post_id, 'geo_latitude', true);
			// geo_public geo_enabled
			$geo_public = get_post_meta($post_id, 'geo_public', true);
			$geo_enabled = get_post_meta($post_id, 'geo_enabled', true);
			if ($geo_public == '1' && $geo_enabled =='1')
			{
                        $returnme .= '
				map.setCenterAtLonLat('. $lon .','. $lat .',10);
                        ';
      }
	}
 
/******************************************************************************/
	$returnme .= '
		     		};//function;

		</script>
		';

	if($attr['apiVersion'] !='1.3')
	{
		$returnme .= '		
		<script type="text/javascript"  src="http://api.ign.fr/geoportail/api/js/' .$attr['apiVersion'] . '-e/GeoportalExtended.js"> <!-- --></script>
		
		';
	}
	else
	{
		$returnme .= '          
                <script type="text/javascript"  src="http://depot.ign.fr/geoportail/api/js/1.3/GeoportalExtended.js"> <!-- --></script>
		';		
	}
/******************************************************************************/
		return $returnme;
}

add_shortcode('geoportail', 'geoportailme');

